#include <metatask.h>
#include "ccmetaerror.h"
#include "cctaskwarning.h"
#include "cctaskerror.h"
#include <ExceptionErrorHandler.h>

void ccmetaerror()
{
  ExceptionErrorHandler local;
  ErrorHandler* oldHandler = errHandler.handler(&local);
  errHandler.name(oldHandler->name());

  for (int i=0;i<2;i++) {

    // 'stupido' query, only to see, whether Task object is consistent after
    // an error occured in a child task!
    Info::Task* me= Info::Task::current();
    ParameterInfo& mypars= *(me->parameters());
    bool myval=mypars["isset"];

    cout << "Looked up variable['isset']="<<myval<<endl;

    try {
      task(cctaskerror);
    }
    catch (SasException::Error e) {
      errstr << "Continuing... after error::" << e.name << "::" << e.code <<
	Sas::warning("ChildFailed");
    }
    catch (SasException::Fatal e) {
      errstr << "Continuing... after fatal::" << e.name << "::" << e.code <<
	Sas::warning("ChildFailed");
    }
    catch (...) {
      errHandler.handler(oldHandler);
      errstr << "Fatal... after fatal" << Sas::fatal("ChildFailed");
    }
    

  }

  errHandler.handler(oldHandler); // return to default error handler
}
